# encoding: utf-8
require 'pinkyblog/application/core'

module PinkyBlog
	class Application
		def export_to_mtlog(entries)
			buf = StringIO.new
			
			entries.each do |entry|
				# メタデータ
				buf.puts "TITLE: #{entry.title}"
				buf.puts "DATE: #{Util.format_to_mtdate(entry.created)}"
				#buf.puts "AUTHOR: #{}"
				entry.normal_tags.each do |tag|
					buf.puts "CATEGORY: #{tag}"
				end
				buf.puts "STATUS: #{(entry.visible? ? 'Publish' : 'Draft')}"
				buf.puts "ALLOW COMMENTS: #{entry.tags.include?('！コメント不可') ? '0' : '1'}"
				buf.puts "CONVERT BREAKS: 0"
				buf.puts "-----"
				
				# 記事本文
				buf.puts 'BODY:'
				buf.puts @module_handler.translate(entry.format, entry.content)
				buf.puts "-----"
	
				# コメント
				entry.comments.each do |comment|
					buf.puts 'COMMENT:'
					buf.puts "AUTHOR: #{comment.writer}" if comment.writer
					buf.puts "EMAIL: #{comment.mail_address}" if comment.mail_address
					buf.puts "DATE: #{Util.format_to_mtdate(comment.time)}"
					buf.puts comment.content
					buf.puts "-----"
				end
				
				buf.puts "--------"
	
			end
			
			return buf.string
		end


=begin
		def export_to_yaml
			@repository.lock{
				entries = @repository.load_all_entries
				entries.sort!{|a, b| a.id <=> b.id}
				open('exported.yaml', 'w'){|output|
				Zlib::GzipWriter.open('exported.yaml.gz'){|gz_output|
					
					entries.each do |entry|
						data = {}
						data['Title'] = entry.title
						data['Visible'] = entry.visible
						data['ID'] = entry.id
						data['Body'] = entry.content
						data['Updated'] = entry.last_modified
						data['Created'] = entry.created

						
						data['Images'] = []
						load_attached_images(entry.id).each do |image|
							body = (@config.attached_dir_path + "#{entry.id}_#{image.name}").read
							
							data['Images'] << {'Name' => image.name, 'Body' => [body].pack('m*')}
						end
						
						data['Comments'] = []
						entry.comments.each do |comment|
							data['Comments'] << {
								'Body' => comment.content,
								'Writer' => comment.writer,
								'Time' => comment.time,
								'UUID' => comment.uuid,
								'Edited-Number' => comment.edited_number,
								'Password-SHA' => comment.password_sha,
							}
						end
						
						output.puts data.ya2yaml
						gz_output.puts data.ya2yaml
					end
				}
				}
			}
		end

=end
	end
end